#!/bin/bash

# Fix the hardware clock settings....

ARC=0
UTC=0
if [ -f /etc/sysconfig/clock ]; then
    . /etc/sysconfig/clock

    # convert old style clock config to new values
    if [ "${CLOCKMODE}" = "GMT" ]; then
            UTC=true
    elif [ "${CLOCKMODE}" = "ARC" ]; then
            ARC=true
    fi
fi

CLOCKDEF=""
if [ -x /sbin/hwclock ]; then
    CLOCKFLAGS="--systohc"
    CLOCK=/sbin/hwclock
else
    CLOCKFLAGS="-a"
    CLOCK=/sbin/clock
fi

case "$UTC" in
  yes|true)
    CLOCKFLAGS="$CLOCKFLAGS -u";
    CLOCKDEF="$CLOCKDEF (utc)";
  ;;
esac

if [ "$CLOCK" = "/sbin/clock" ]; then
 case "$ARC" in
   yes|true)
     CLOCKFLAGS="$CLOCKFLAGS -A";
     CLOCKDEF="$CLOCKDEF (arc)";
   ;;
 esac
fi

# Now that we are all knowing, do the dirty work.
$CLOCK $CLOCKFLAGS
if [ -e /etc/adjtime ]; then
    rm /etc/adjtime
fi
$CLOCK $CLOCKFLAGS

