#!/usr/bin/perl -w
use strict;
use Fcntl;

my (@modules, $module, $system, @inuse);
my $newusr = 'nobody';
my $newuid = '99';
my $sitehm = '/home/sites';
$|=1;

## Determine System
if ( ! ( system( "grep -q 3000R /etc/build" ) ) ) { # 1 on error
	push @modules, '/usr/lib/perl5/site_perl/5.005/Cobalt/Fpx.pm';
	push @modules, '/usr/lib/perl5/site_perl/5.005/Cobalt/Vsite.pm';
	push @modules, '/usr/lib/perl5/site_perl/5.005/Cobalt/Group.pm';
	$system = 3;
} elsif ( ! ( system( "grep -q 2800R /etc/build" ) ) ) {
	push @modules, '/usr/lib/perl5/site_perl/Cobalt/Fpx.pm';
	push @modules, '/usr/lib/perl5/site_perl/Cobalt/Vsite.pm';
	push @modules, '/usr/lib/perl5/site_perl/Cobalt/Group.pm';
	$system = 2;
} else {
	exit 1;
}

## Fix Module(s)
foreach $module ( @modules ) {
	system("cp $module $module.pkgsave");
	sysopen( PRD, $module, O_RDONLY ) or 
		die "Failed to open $module for reading: $!\n";
	sysopen( PRDNU, "$module.new", O_WRONLY|O_CREAT ) or
		die "Failed to open $module.new for writing: $!\n";
	while( <PRD> ) {
		if ( ! /\$WWWuser|\$WWWuid/ ) { print PRDNU $_; next; }
		$_ =~ s/\$WWWuser/\"nobody\"/ if /\$WWWuser/;
		$_ =~ s/\$WWWuid/$newuid/ if /\$WWWuid/;
		print PRDNU $_;
	}
	close PRD;
	close PRDNU;
	rename( "$module.new", $module );
}

## If we are on a RaQ2 we need to fix the autoized routines.
if ( $system == 2 ) {
	my $al;
	my $base = '/usr/lib/perl5/site_perl/auto/Cobalt';
	my @als = qw( Fpx/fpx_set_web.al 
	              Vsite/vsite_add.al 
	              Group/group_add.al
	              Group/group_mkdiscuss.al
	              Group/group_show.al );

	foreach $al ( @als ) {
		system("cp $base/$al $base/$al.pkgsave");
		sysopen( PRD, "$base/$al", O_RDONLY ) or
			die "Failed to open $base/$al for reading: $!\n";
		sysopen( PRDNU, "$base/$al.new", O_WRONLY|O_CREAT ) or
			die "Failed to open $base/$al.new for writing: $!\n";
		while( <PRD> ) {
			if ( ! /\$WWWuser|\$WWWuid/ ) { print PRDNU $_; next; }
			next if /^my \$WWW/;
			$_ =~ s/\$WWWuser/\"nobody\"/ if /\$WWWuser/;
			$_ =~ s/\$WWWuid/$newuid/ if /\$WWWuid/;
			print PRDNU $_;
		}
		close PRD;
		close PRDNU;
		rename( "$base/$al.new", "$base/$al" );
	}

}


## Modify Frontpage File Permissions
system("echo STARTING PERMISSIONING >> /var/cobalt/adm.log");
open( FND, "/usr/bin/find $sitehm  -user httpd -printf \"%p\t%U\t%G\t%m\n\" |" )
	or die "Failed to open pipe from find: $!\n";
while( <FND> ) {
	chomp;
	# Write the permissions to adm.log ( space hog, but worth it
	# if "bad things"tm happen )
	system( "echo $_ >> /var/cobalt/adm.log" );
	
	my @info = split(/\t/, $_);
	# [0] - filename
	# [1] - current uid
	# [2] - curreng gid
	# [3] - current mode
	
	# set new ownership
	chown $newuid, $info[2], "$info[0]";
	# set back the proper permissions ( ugh!!! perl's chmod !%*$^s )
	system("chmod $info[3] \'$info[0]\'");
}
close FND;
system("echo ENDING PERMISSIONING >> /var/cobalt/adm.log");

exit 0;
