#!/usr/bin/perl

use GDBM_File;
use POSIX qw/tmpnam/;

$DBFILE = "/etc/pop.auth";
die "APOP database does not exist at $DBFILE!" unless (-e $DBFILE);
do { $DBTEMP = POSIX::tmpnam(); } until (! -e $DBTEMP);

rename($DBFILE, $DBTEMP);
die "error moving APOP database from $DBFILE to $DBTEMP!"
        unless (-f $DBTEMP && ! -e $DBFILE);

system("/usr/sbin/popauth -init");

tie %oldDB, GDBM_File, $DBTEMP, GDBM_READER, 0600
        or die "cant open old APOP database: $!\n";
tie %newDB, GDBM_File, $DBFILE, GDBM_WRITER, 0600
        or die "cant open new APOP database: $!\n";

foreach my $user (keys %oldDB)
{
        my($U,$P,$plainpw,$obscurepw);

        foreach (unpack('C*', $oldDB{$user})) {
                $plainpw .= pack('C*', $_ ^= hex("ff"));
        }

        $U = $user . chr(0);
        $P = substr($plainpw, 0, -1) . chr(255) . chr(255);

        foreach (unpack('C*', $P)) {
                $obscurepw .= pack('C*', $_ ^= hex("ff"));
        }

        $newDB{$U} = $obscurepw;
}

untie %newDB;
untie %oldDB;
unlink($DBTEMP);
exit 0;
