#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 3.0
#
# Version 2.0 uses Monitor.pm instead of AlertDB.pm
#
# date: 6-28-99
#
# Copyright 1999-2000, Cobalt Networks, Inc
# All rights reserved

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::swatch;

use strict;
use CGI;
use Locale::gettext;

# global variables
my $q=new CGI;

# the page that run this script
my $page=$q->param('page');

my $alertScriptURL='/cgi-bin/.cobalt/alert/alert.cgi';

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

# get ball colors
my (%balls,$defcon,$obj,@items,$comp,$service,$item);

# cpu
$balls{"cpu"} = $defcon_images{ swatch_get_defcon("cpu") };
# memory
$balls{"memory"} = $defcon_images{ swatch_get_defcon("memory") };
# network
$balls{"network"} = $defcon_images{ 1 };
# disk
$balls{"disk"} = $defcon_images{ swatch_get_defcon_disk() };

# now do services
my @services = ("http", "ftp", "snmp", "dns", "telnet");
foreach $service (@services) {
    $balls{ $service } = $defcon_images{ swatch_get_defcon("service", $service) };
}
# don't forget email
$balls{"email"} = $defcon_images{ swatch_get_defcon_email() };

# Read in the template
open( TEMPLATE, "$Template_dir/alert.tmpl" )
    || die "Cannot read $Template_dir/alert.tmpl: $!\n";

print "content-type: text/html\nCache-Control: no-cache\n\n";

while ( <TEMPLATE> ) {
    s/\[CPU\]/$balls{"cpu"}/o;
    s/\[MEMORY\]/$balls{"memory"}/o;
    s/\[DISK\]/$balls{"disk"}/o;
    s/\[NETWORK\]/$balls{"network"}/o;

    s/\[FTP\]/$balls{"ftp"}/o;
    s/\[EMAIL\]/$balls{"email"}/o;
    s/\[TELNET\]/$balls{"telnet"}/o;
    s/\[HTTP\]/$balls{"http"}/o;
    s/\[SNMP\]/$balls{"snmp"}/o;
    s/\[DNS\]/$balls{"dns"}/o;

    s/\[DEFCON0\]/$defcon_images{ 0 }/o;
    s/\[DEFCON1\]/$defcon_images{ 1 }/o;
    s/\[DEFCON2\]/$defcon_images{ 2 }/o;
    s/\[DEFCON3\]/$defcon_images{ 3 }/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    print;
}

close TEMPLATE;
