#!/usr/bin/perl

# Restore menu V3
# Copyright 1998 Cobalt Networks Inc

use Cobalt::Product;
require Cobalt::Vsite;
require Cobalt::Language;
require Cobalt::Locale;
use CGI;
use strict;
use Locale::gettext;

my($user,$UserError,$mode,$backups,@files,$file,$group,$q);

sub siteAdmin
{
    my($u) = @_;
    return 1 if (grep /^$u$/, Cobalt::Vsite::vsite_admin_list());
    return 0;
}

$user = $ENV{"REMOTE_USER"};
$q = new CGI;
$group = $q->param( 'group' );

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

if ($ENV{'QUERY_STRING'} =~ /USERERROR=([^\#]+)#/) {
    $UserError ='<IMG SRC="/.cobalt/images/bang.gif" ALIGN=CENTER>'.$1;
}

if ($user eq "admin") {
    $mode = "admin";
} else {
    if( siteAdmin($user) && $group ) { $mode = "site"; } else { $mode = "user"; }
}

my $homedir=(getpwnam($user))[7];

my $restore_homedir_help = eval("\"".dgettext('ui', 'restore_homedir_help')."\"");
my $homedirheader = "\n\t<tr>\n\t\t<td width=\"26\">\n\t\t\t<center><a href=\"javascript: top.showInfo( homedirHelp );\" onMouseOver=\"status=\'Help\'; top.showInfo( homedirHelp ); return true;\"><img src=\"/.cobalt/images/smallest_help_but.gif\" align=\"bottom\" border=\"0\"></a></center>\n\t\t</td>\n\t\t<td><font bgcolor=#FFFFFF>&nbsp; $restore_homedir_help </font>\n\t\t</td>\n\t\t<td>";

if (-d $homedir) {
  opendir(HOME,"$homedir");
  @files = readdir(HOME);
  foreach $file (@files) {
    $backups .= "<option value=\"$file\">$file</option>\n" if ($file =~ /\.raq$/);
  }
  $backups = $homedirheader."<select name=\"homedirarchive\">".$backups."</select></td></tr>" if ($backups);
  closedir(HOME);
}

# Read in the template
open (TEMPLATE, "$Template_dir/restoremenu.tmpl")
      || die "Cannot read $Template_dir/restoremenu.tmpl: $!\n";

print "content-type: text/html \nCache-Control: no-cache\n\n";
while( <TEMPLATE> ) {
    # Do our substitutions
    s/\[USER\]/$user/o;
    s/\[BACKUPS\]/$backups/o;
    s/\[USERERROR\]/$UserError/o;
    s/\[MODE\]/$mode/o;
    s/\[GROUP\]/$group/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    # Write out the form...
    print;
}
close TEMPLATE;

