#!/usr/bin/perl

# author: Kevin K.M. Chiu
#       Cobalt Networks
# version: 3.0
# date: 7-2-98
#
# Version 2.0 uses Monitor.pm instead of AlertDB.pm
#
# Copyright 1998-1999, Cobalt Networks, Inc
# All rights reserved

use Cobalt::Product;
use Cobalt::Locale;
use Cobalt::Meta;
use Cobalt::Network;

#use GIFgraph::pie;
use strict;
use CGI;
use Locale::gettext;

#
# global variables
#
my $alertScriptURL='/cgi-bin/.cobalt/alert/alert.cgi';

my $q=new CGI;

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

# read network data
my @if = Cobalt::Network::net_get_interfaces();
undef my %if;
for (@if) { $if{$_} = 1; }
my (%eth0,%eth1);
my @data = ("in_bytes", "out_bytes", "in_packets", "out_packets", "errors", "collisions");

my $oe0 = Cobalt::Meta->create("type" => "network");
$oe0->retrieve("eth0");
my $oe1 = Cobalt::Meta->create("type" => "network");
$oe1->retrieve("eth1");

foreach (@data) {
    $eth0{$_} = int($oe0->get($_));
    $eth1{$_} = int($oe1->get($_));
}

my $back;
if ($q->param('alert')) {
    $back = "<A HREF=\"$alertScriptURL\"><IMG SRC=\"/.cobalt/images/back_but.gif\" BORDER=0></A>";
}

# Read in the template
open( TEMPLATE, "$Template_dir/networkUsage.tmpl" )
    || die "Cannot read $Template_dir/networkUsage.tmpl: $!\n";

print "Content-type: text/html\nCache-Control: no-cache\n\n";

while ( <TEMPLATE> ) {
    s/\[ETH0_IN_BYTES\]/$eth0{"in_bytes"}/o;
    s/\[ETH0_OUT_BYTES\]/$eth0{"out_bytes"}/o;
    s/\[ETH0_IN_PACKETS\]/$eth0{"in_packets"}/o;
    s/\[ETH0_OUT_PACKETS\]/$eth0{"out_packets"}/o;
    s/\[ETH0_ERRORS\]/$eth0{"errors"}/o;
    s/\[ETH0_COLLISIONS\]/$eth0{"collisions"}/o;

    s/\[ETH1_IN_BYTES\]/$eth1{"in_bytes"}/o;
    s/\[ETH1_OUT_BYTES\]/$eth1{"out_bytes"}/o;
    s/\[ETH1_IN_PACKETS\]/$eth1{"in_packets"}/o;
    s/\[ETH1_OUT_PACKETS\]/$eth1{"out_packets"}/o;
    s/\[ETH1_ERRORS\]/$eth1{"errors"}/o;
    s/\[ETH1_COLLISIONS\]/$eth1{"collisions"}/o;

    s/\[BACK\]/$back/o;

    s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

    if (exists $if{'eth1'}) {
	s/\[BEGINHIDEETH1\]//o;
	s/\[ENDHIDEETH1\]//o;
    } else {
	s/\[BEGINHIDEETH1\]/<!-- /o;
	s/\[ENDHIDEETH1\]/ --> /o;
    }

    print;
}

close TEMPLATE;

1;
