#!/usr/bin/perl

# author: John D. Blair
#       Cobalt Networks
# version: 1.0
# date: 20.jul.99
#
# Copyright (C) 1999, Cobalt Networks, Inc
# All rights reserved

use Cobalt::Product;
use Cobalt::Locale;

require Cobalt::Services;
require Cobalt::Legato;

use Locale::gettext;
use CGI;
use strict;

# global variables
my $networkerScriptURL='/cgi-bin/.cobalt/networker/networker.cgi';
my $networkerPageURL='/cgi-bin/.cobalt/services/services.cgi';

my $q=new CGI;

my $locale=Cobalt::Locale->getByHTTPHeader( $ENV{ 'HTTP_ACCEPT_LANGUAGE' } );
if( $locale ) { $ENV{ 'LANGUAGE' }=$locale->getLocale(); }

my $page=$q->param( 'page' );

if( $page ne 'networker' ) { genPage( \*STDOUT ); }
else {
    my $err=0;
    my $info='<IMG SRC="/.cobalt/images/bang.gif" ALIGN=CENTER>';

    # read form input
    my $hostname=$q->param( 'hostname' );
    my $ipaddr=$q->param( 'ipaddr' );

    # let the sauce call do the error checking
    my $ret=Cobalt::Legato::legato_set_serveraddr( $hostname, $ipaddr );
    if( $ret!~/^2/o ) {
      $info.=substr( $ret, 4 ).'<BR>';
      $err=1;
    }

    if( !$err ) { print "location: $networkerPageURL\n\n"; }
    else { genPage( \*STDOUT, $info ); }
}

1;


#
# argument 0 is the file handle the page goes to
# argument 1 is the infomation shown to user
#
sub genPage {
    my ( $handle, $info )=@_;
    my $hostname;
    my $ipaddr;
    my ( $hostname, $ipaddr )=Cobalt::Legato::legato_get_serveraddr();

    # Read in the template
    open( TEMPLATE, "$Template_dir/networker.tmpl" )
          || die "Cannot read $Template_dir/networker.tmpl: $!\n";

    print "content-type: text/html \nCache-Control: no-cache\n\n";
    while( <TEMPLATE> ) {
        s/\[HOSTNAME\]/$hostname/o;
        s/\[SCRIPTURL\]/$networkerScriptURL/o;
        s/\[SERVICESPAGEURL\]/$networkerPageURL/o;
        s/\[IPADDR\]/$ipaddr/o;
        s/\[USER_INFO\]/$info/o;
        s/\[str.([^\]]+)\]/Locale::gettext::dgettext("ui", "$1")/geo;

        print $handle $_;
    }
    close TEMPLATE;
}
